mirror of
https://github.com/prdlk/leetcode.git
synced 2026-11-02 21:22:43 +00:00
Compare commits
6
Commits
| Author | SHA1 | Date | |
|---|---|---|---|
|
|
00f44a1c47 | ||
|
|
24312437eb | ||
|
|
4c9c8f39ae | ||
|
|
88ff63f5c4 | ||
|
|
2066856d15 | ||
|
|
393d72c9fe |
No files matched your search
@@ -0,0 +1,41 @@
|
|||||||
|
---
|
||||||
|
title: '215. Kth Largest Element in an Array'
|
||||||
|
description: Given an integer array nums and an integer k, return the k^th largest element in the array
|
||||||
|
sidebar:
|
||||||
|
label: 'Kth Largest Element in an Array'
|
||||||
|
badge: 'Medium'
|
||||||
|
---
|
||||||
|
|
||||||
|
<Badge variant="accent">Heap / Priority Queue</Badge>
|
||||||
|
|
||||||
|
### Example 1:
|
||||||
|
- Input: `nums = [3,2,1,5,6,4], k = 2`
|
||||||
|
- Output: `5`
|
||||||
|
|
||||||
|
### Example 2:
|
||||||
|
- Input: `nums = [3,2,3,1,2,4,5,5,6], k = 4`
|
||||||
|
- Output: `4`
|
||||||
|
|
||||||
|
### Constraints:
|
||||||
|
|
||||||
|
- `1 <= k <= nums.length <= 10^5`
|
||||||
|
- `-10^4 <= nums[i] <= 10^4`
|
||||||
|
|
||||||
|
## Solution
|
||||||
|
|
||||||
|
```py
|
||||||
|
import heapq
|
||||||
|
|
||||||
|
|
||||||
|
class Solution:
|
||||||
|
def findKthLargest(self, nums: List[int], k: int) -> int:
|
||||||
|
for i in range(len(nums)):
|
||||||
|
nums[i] = -nums[i]
|
||||||
|
|
||||||
|
heapq.heapify(nums)
|
||||||
|
|
||||||
|
for _ in range(k - 1):
|
||||||
|
heapq.heappop(nums)
|
||||||
|
|
||||||
|
return -heapq.heappop(nums)
|
||||||
|
```
|
||||||
@@ -0,0 +1,48 @@
|
|||||||
|
---
|
||||||
|
title: '973. K Closest Points to Origin'
|
||||||
|
description: Given an array of points where points[i] = [xi, yi] represents a point on the X-Y plane and an integer k, return the k closest points to the origin (0, 0)
|
||||||
|
sidebar:
|
||||||
|
label: 'K Closest Points to Origin'
|
||||||
|
badge: 'Medium'
|
||||||
|
---
|
||||||
|
|
||||||
|
<Badge variant="accent">Heap / Priority Queue</Badge>
|
||||||
|
|
||||||
|
### Example 1:
|
||||||
|
- Input: `points = [[1,3],[-2,2]], k = 1`
|
||||||
|
- Output: `[[-2,2]]`
|
||||||
|
- Explanation: The distance between `(1`, `3`) and the origin is sqrt(10). The distance between `(-2`, `2`) and the origin is sqrt(8). Since sqrt(8) < sqrt(10), `(-2`, `2`) is closer to the origin. We only want the closest `k = 1 points` from the origin, so the answer is just [[-2,2]].
|
||||||
|
|
||||||
|
### Example 2:
|
||||||
|
- Input: `points = [[3,3],[5,-1],[-2,4]], k = 2`
|
||||||
|
- Output: `[[3,3],[-2,4]]`
|
||||||
|
- Explanation: The answer [[-2,4],[3,3]] would also be accepted.
|
||||||
|
|
||||||
|
### Constraints:
|
||||||
|
|
||||||
|
- `1 <= k <= points.length <= 10^4`
|
||||||
|
- `-10^4 <= xi, yi <= 10^4`
|
||||||
|
|
||||||
|
## Solution
|
||||||
|
|
||||||
|
```py
|
||||||
|
import heapq
|
||||||
|
|
||||||
|
|
||||||
|
class Solution:
|
||||||
|
def kClosest(self, points: List[List[int]], k: int) -> List[List[int]]:
|
||||||
|
minHeap = []
|
||||||
|
for x, y in points:
|
||||||
|
dist = (x**2) + (y**2)
|
||||||
|
minHeap.append([dist, x, y])
|
||||||
|
|
||||||
|
heapq.heapify(minHeap)
|
||||||
|
res = []
|
||||||
|
|
||||||
|
while k > 0:
|
||||||
|
dist, x, y = heapq.heappop(minHeap)
|
||||||
|
res.append([x, y])
|
||||||
|
k -= 1
|
||||||
|
|
||||||
|
return res
|
||||||
|
```
|
||||||
@@ -0,0 +1,69 @@
|
|||||||
|
---
|
||||||
|
title: '23. Merge k Sorted Lists'
|
||||||
|
description: You are given an array of k linked-lists lists, each linked-list is sorted in ascending order
|
||||||
|
sidebar:
|
||||||
|
label: 'Merge k Sorted Lists'
|
||||||
|
badge: 'Hard'
|
||||||
|
---
|
||||||
|
|
||||||
|
<Badge variant="accent">Heap / Priority Queue</Badge>
|
||||||
|
|
||||||
|
### Example 1:
|
||||||
|
- Input: `lists = [[1,4,5],[1,3,4],[2,6]]`
|
||||||
|
- Output: `[1,1,2,3,4,4,5,6]`
|
||||||
|
- Explanation: The linked-lists are: [ 1->4->5, 1->3->4, 2->6 ] merging them into one sorted linked list: 1->1->2->3->4->4->5->6
|
||||||
|
|
||||||
|
### Example 2:
|
||||||
|
- Input: `lists = []`
|
||||||
|
- Output: `[]`
|
||||||
|
|
||||||
|
### Example 3:
|
||||||
|
- Input: `lists = [[]]`
|
||||||
|
- Output: `[]`
|
||||||
|
|
||||||
|
### Constraints:
|
||||||
|
|
||||||
|
- `k == lists.length`
|
||||||
|
- `0 <= k <= 10^4`
|
||||||
|
- `0 <= lists[i].length <= 500`
|
||||||
|
- `-10^4 <= lists[i][j] <= 10^4`
|
||||||
|
- `lists[i]` is sorted in ascending order.
|
||||||
|
- The sum of lists[i].length will not exceed 10^4.
|
||||||
|
|
||||||
|
## Solution
|
||||||
|
|
||||||
|
```py
|
||||||
|
# Definition for singly-linked list.
|
||||||
|
# class ListNode:
|
||||||
|
# def __init__(self, val=0, next=None):
|
||||||
|
# self.val = val
|
||||||
|
# self.next = next
|
||||||
|
import heapq
|
||||||
|
|
||||||
|
|
||||||
|
class Solution:
|
||||||
|
def mergeKLists(self, lists: List[Optional[ListNode]]) -> Optional[ListNode]:
|
||||||
|
heap = []
|
||||||
|
|
||||||
|
# K log K
|
||||||
|
for i, node in enumerate(lists):
|
||||||
|
if node:
|
||||||
|
heapq.heappush(heap, (node.val, i, node))
|
||||||
|
|
||||||
|
D = ListNode()
|
||||||
|
cur = D
|
||||||
|
|
||||||
|
# n log k
|
||||||
|
while heap:
|
||||||
|
val, i, node = heapq.heappop(heap)
|
||||||
|
cur.next = node
|
||||||
|
cur = node
|
||||||
|
node = node.next
|
||||||
|
|
||||||
|
if node:
|
||||||
|
heapq.heappush(heap, (node.val, i, node))
|
||||||
|
|
||||||
|
# Time: O(N log k)
|
||||||
|
# Space: O(n)
|
||||||
|
return D.next
|
||||||
|
```
|
||||||
@@ -0,0 +1,87 @@
|
|||||||
|
"""
|
||||||
|
23. Merge k Sorted Lists
|
||||||
|
Difficulty: Hard
|
||||||
|
https://leetcode.com/problems/merge-k-sorted-lists/
|
||||||
|
|
||||||
|
──────────────────────────────────────────────────
|
||||||
|
|
||||||
|
You are given an array of k linked-lists lists, each linked-list is
|
||||||
|
sorted in ascending order.
|
||||||
|
|
||||||
|
Merge all the linked-lists into one sorted linked-list and return it.
|
||||||
|
|
||||||
|
|
||||||
|
|
||||||
|
Example 1:
|
||||||
|
|
||||||
|
Input: lists = [[1,4,5],[1,3,4],[2,6]]
|
||||||
|
Output: [1,1,2,3,4,4,5,6]
|
||||||
|
Explanation: The linked-lists are:
|
||||||
|
[
|
||||||
|
1->4->5,
|
||||||
|
1->3->4,
|
||||||
|
2->6
|
||||||
|
]
|
||||||
|
merging them into one sorted linked list:
|
||||||
|
1->1->2->3->4->4->5->6
|
||||||
|
|
||||||
|
Example 2:
|
||||||
|
|
||||||
|
Input: lists = []
|
||||||
|
Output: []
|
||||||
|
|
||||||
|
Example 3:
|
||||||
|
|
||||||
|
Input: lists = [[]]
|
||||||
|
Output: []
|
||||||
|
|
||||||
|
|
||||||
|
|
||||||
|
Constraints:
|
||||||
|
|
||||||
|
• k == lists.length
|
||||||
|
|
||||||
|
• 0 <= k <= 10^4
|
||||||
|
|
||||||
|
• 0 <= lists[i].length <= 500
|
||||||
|
|
||||||
|
• -10^4 <= lists[i][j] <= 10^4
|
||||||
|
|
||||||
|
• lists[i] is sorted in ascending order.
|
||||||
|
|
||||||
|
• The sum of lists[i].length will not exceed 10^4.
|
||||||
|
"""
|
||||||
|
|
||||||
|
# Definition for singly-linked list.
|
||||||
|
# class ListNode:
|
||||||
|
# def __init__(self, val=0, next=None):
|
||||||
|
# self.val = val
|
||||||
|
# self.next = next
|
||||||
|
import heapq
|
||||||
|
|
||||||
|
|
||||||
|
class Solution:
|
||||||
|
def mergeKLists(self, lists: List[Optional[ListNode]]) -> Optional[ListNode]:
|
||||||
|
heap = []
|
||||||
|
|
||||||
|
# K log K
|
||||||
|
for i, node in enumerate(lists):
|
||||||
|
if node:
|
||||||
|
heapq.heappush(heap, (node.val, i, node))
|
||||||
|
|
||||||
|
D = ListNode()
|
||||||
|
cur = D
|
||||||
|
|
||||||
|
# n log k
|
||||||
|
while heap:
|
||||||
|
val, i, node = heapq.heappop(heap)
|
||||||
|
cur.next = node
|
||||||
|
cur = node
|
||||||
|
node = node.next
|
||||||
|
|
||||||
|
if node:
|
||||||
|
heapq.heappush(heap, (node.val, i, node))
|
||||||
|
|
||||||
|
# Time: O(N log k)
|
||||||
|
# Space: O(n)
|
||||||
|
return D.next
|
||||||
@@ -0,0 +1,50 @@
|
|||||||
|
"""
|
||||||
|
215. Kth Largest Element in an Array
|
||||||
|
Difficulty: Medium
|
||||||
|
https://leetcode.com/problems/kth-largest-element-in-an-array/
|
||||||
|
|
||||||
|
──────────────────────────────────────────────────
|
||||||
|
|
||||||
|
Given an integer array nums and an integer k, return the k^th largest
|
||||||
|
element in the array.
|
||||||
|
|
||||||
|
Note that it is the k^th largest element in the sorted order, not the
|
||||||
|
k^th distinct element.
|
||||||
|
|
||||||
|
Can you solve it without sorting?
|
||||||
|
|
||||||
|
|
||||||
|
|
||||||
|
Example 1:
|
||||||
|
|
||||||
|
Input: nums = [3,2,1,5,6,4], k = 2
|
||||||
|
Output: 5
|
||||||
|
|
||||||
|
Example 2:
|
||||||
|
|
||||||
|
Input: nums = [3,2,3,1,2,4,5,5,6], k = 4
|
||||||
|
Output: 4
|
||||||
|
|
||||||
|
|
||||||
|
|
||||||
|
Constraints:
|
||||||
|
|
||||||
|
• 1 <= k <= nums.length <= 10^5
|
||||||
|
|
||||||
|
• -10^4 <= nums[i] <= 10^4
|
||||||
|
"""
|
||||||
|
|
||||||
|
import heapq
|
||||||
|
|
||||||
|
|
||||||
|
class Solution:
|
||||||
|
def findKthLargest(self, nums: List[int], k: int) -> int:
|
||||||
|
for i in range(len(nums)):
|
||||||
|
nums[i] = -nums[i]
|
||||||
|
|
||||||
|
heapq.heapify(nums)
|
||||||
|
|
||||||
|
for _ in range(k - 1):
|
||||||
|
heapq.heappop(nums)
|
||||||
|
|
||||||
|
return -heapq.heappop(nums)
|
||||||
@@ -0,0 +1,64 @@
|
|||||||
|
"""
|
||||||
|
973. K Closest Points to Origin
|
||||||
|
Difficulty: Medium
|
||||||
|
https://leetcode.com/problems/k-closest-points-to-origin/
|
||||||
|
|
||||||
|
──────────────────────────────────────────────────
|
||||||
|
|
||||||
|
Given an array of points where points[i] = [xi, yi] represents a
|
||||||
|
point on the X-Y plane and an integer k, return the k closest points
|
||||||
|
to the origin (0, 0).
|
||||||
|
|
||||||
|
The distance between two points on the X-Y plane is the Euclidean
|
||||||
|
distance (i.e., √(x1 - x2)^2 + (y1 - y2)^2).
|
||||||
|
|
||||||
|
You may return the answer in any order. The answer is guaranteed to
|
||||||
|
be unique (except for the order that it is in).
|
||||||
|
|
||||||
|
|
||||||
|
|
||||||
|
Example 1:
|
||||||
|
|
||||||
|
Input: points = [[1,3],[-2,2]], k = 1
|
||||||
|
Output: [[-2,2]]
|
||||||
|
Explanation:
|
||||||
|
The distance between (1, 3) and the origin is sqrt(10).
|
||||||
|
The distance between (-2, 2) and the origin is sqrt(8).
|
||||||
|
Since sqrt(8) < sqrt(10), (-2, 2) is closer to the origin.
|
||||||
|
We only want the closest k = 1 points from the origin, so the answer
|
||||||
|
is just [[-2,2]].
|
||||||
|
|
||||||
|
Example 2:
|
||||||
|
|
||||||
|
Input: points = [[3,3],[5,-1],[-2,4]], k = 2
|
||||||
|
Output: [[3,3],[-2,4]]
|
||||||
|
Explanation: The answer [[-2,4],[3,3]] would also be accepted.
|
||||||
|
|
||||||
|
|
||||||
|
|
||||||
|
Constraints:
|
||||||
|
|
||||||
|
• 1 <= k <= points.length <= 10^4
|
||||||
|
|
||||||
|
• -10^4 <= xi, yi <= 10^4
|
||||||
|
"""
|
||||||
|
|
||||||
|
import heapq
|
||||||
|
|
||||||
|
|
||||||
|
class Solution:
|
||||||
|
def kClosest(self, points: List[List[int]], k: int) -> List[List[int]]:
|
||||||
|
minHeap = []
|
||||||
|
for x, y in points:
|
||||||
|
dist = (x**2) + (y**2)
|
||||||
|
minHeap.append([dist, x, y])
|
||||||
|
|
||||||
|
heapq.heapify(minHeap)
|
||||||
|
res = []
|
||||||
|
|
||||||
|
while k > 0:
|
||||||
|
dist, x, y = heapq.heappop(minHeap)
|
||||||
|
res.append([x, y])
|
||||||
|
k -= 1
|
||||||
|
|
||||||
|
return res
|
||||||
Reference in new issue
Block a user